import java.sql.*;

public class Connexion
{
   private static final String
      URI_SOURCE = "jdbc:odbc:POQ",
      CLASSE_PILOTE = "sun.jdbc.odbc.JdbcOdbcDriver";

   private boolean m_ConnexionOuverte;
   private Connection m_Connexion;

   private static Connexion Singleton = null;
   private int m_NbUsagers;
   public static Connexion GetConnexion ()
   {
      if (Singleton == null)
         Singleton = new Connexion ();
      Singleton.AjouterRfrence ();
      return Singleton;
   }
   public void RelcherConnexion ()
   {
      m_NbUsagers --;
      if (m_NbUsagers == 0)
      {
         Terminer ();
         Singleton = null;
      }
   }
   private void AjouterRfrence ()
   {
      m_NbUsagers ++;
   }
   // Mthode Terminer()
   //
   // Ferme la connexion  la BD (si elle est ouverte)
   //
   // Cas d'exception possibles
   // -- erreur SQL (ex: BD pas ouverte)
   private void Terminer ()
   {
      if (m_Connexion != null)
      {
         try
         {
            m_Connexion.close ();
         }
         catch (SQLException sqle)
         {
            System.err.println (sqle.getMessage ());
         }
         m_Connexion = null; // pour simplifier la collecte d'ordures
      }
   }

   private Connexion ()
   {
      m_NbUsagers = 0;
      m_ConnexionOuverte = false;
      m_Connexion = null;
      try
      {
         // -- Charger la classe pilote
         Class.forName (CLASSE_PILOTE);
         m_Connexion = DriverManager.getConnection (URI_SOURCE);
         m_ConnexionOuverte = true;
      }
      catch (ClassNotFoundException cnfe)
      {
         System.err.println (cnfe.getMessage ());
      }
      catch (SQLException sqle)
      {
         System.err.println (sqle.getMessage ());
      }
   }
   public boolean EstOuverte () { return m_ConnexionOuverte; }
   public Statement Crernonc() throws SQLException
   {
      return m_Connexion.createStatement ();
   }
}
