import java.sql.*;
import java.util.Vector;
import java.util.Iterator;

public class POQExplorateur_v1
{
   //
   // La connexion
   //
   private Connexion m_Connexion;

   public POQExplorateur_v1 ()
   {
      m_Connexion = Connexion.GetConnexion ();
   }

   public boolean ConnexionOuverte ()
   {
      return m_Connexion.EstOuverte ();
   }
   public void Terminer ()
   {
      m_Connexion.RelcherConnexion();
   }

   // Mthode GetListePropritaires ()
   //
   // Extrait la liste des noms de propritaires, les insre dans
   // un vecteur (tableau dynamique) et retourne ce vecteur
   public Vector GetListePropritaires ()
   {
      final String SQL_LISTE_PROPRITAIRES =
         "Select NomProprio From POQProprio";

      Vector v = new Vector ();
      try
      {
         Statement stmt = m_Connexion.Crernonc ();
         ResultSet results = stmt.executeQuery (SQL_LISTE_PROPRITAIRES);
         while (results.next ())
            v.add (results.getString ("NomProprio"));
         results.close ();
      }
      catch (SQLException sqle)
      {
         System.err.println (sqle.getMessage ());
      }
      return v;
   }


   // Programme principal
   //
   // Ouvre une connexion  la BD; en extrait la liste des propritaires
   // de POQmon (leur nom seulement); affiche cette liste; puis ferme la
   // connexion
   public static void main (String [] args)
   {
      POQExplorateur_v1 pe = new POQExplorateur_v1();
      if (pe.ConnexionOuverte ())
      {
         Vector v = pe.GetListePropritaires ();
         Iterator itt = v.iterator ();
         System.out.println ("Liste des propritaires de POQmon:");
         while (itt.hasNext ())
            System.out.println ((String) itt.next ());
         pe.Terminer ();
      }
   }
}
